From a64995f4cb4dc4590c5a114a9cd1ca36976e274c Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jun 09 2015 01:40:48 +0000
Subject: [PATCH 108/1001] Allow widgets to know who is logged in, so they can display themselves differently.


---

diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index e864e5b..76c5748 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -74,6 +74,15 @@ def prepare_registry(registry):
 validate_registry(registry)
 prepare_registry(registry)
 
+
+def get_site_vars():
+    import flask
+    return dict(
+        session=flask.app.session,
+        g=flask.g,
+    )
+
+
 def render(module, session, widget, *args, **kwargs):
     """ Main API entry point.
 
@@ -82,5 +91,8 @@ def render(module, session, widget, *args, **kwargs):
     # The API returns exactly this data.  Shared cache
     data = module.data(session, widget, *args, **kwargs)
 
+    # Also expose some site-level info to the widget here at render-time
+    data.update(get_site_vars())
+
     # Use the API data to fill out a template, and potentially decorate it.
     return module.render(**data)
diff --git a/hubs/widgets/fedmsgstats.py b/hubs/widgets/fedmsgstats.py
index 5f985af..2f075ab 100644
--- a/hubs/widgets/fedmsgstats.py
+++ b/hubs/widgets/fedmsgstats.py
@@ -2,9 +2,13 @@ from hubs.hinting import hint
 from hubs.widgets.chrome import panel
 
 import jinja2
-
 import requests
 
+import fedmsg.config
+import fedmsg.meta
+
+config = fedmsg.config.load_config()
+
 chrome = panel()
 template = jinja2.Template("""
 <div class="stats-container">
@@ -12,7 +16,9 @@ template = jinja2.Template("""
     <tr><th>FedMsgs</th><th>Subscribers</th></tr>
     <tr class="text-info"><td>{{fedmsgs}}</td><td>{{subscribers}}</td></tr>
   </table>
+  {% if session['nickname'] != username %}
   <div class="pull-right"><button class="btn btn-info">Subscribe</button></div>
+  {% endif %}
 </div>
 """)
 
@@ -23,6 +29,7 @@ def data(session, widget, username):
     response = requests.get(url)
     fedmsgs = response.json()['total']
     return dict(
+        username=username,
         fedmsgs=fedmsgs,
         subscribers=len(widget.hub.subscribers),
     )
diff --git a/hubs/widgets/workflow/pendingacls.py b/hubs/widgets/workflow/pendingacls.py
index 9e40b73..6bcee7b 100644
--- a/hubs/widgets/workflow/pendingacls.py
+++ b/hubs/widgets/workflow/pendingacls.py
@@ -12,8 +12,10 @@ import hubs.validators as validators
 # TODO -- add approve/deny buttons or just link through to pkgdb
 template = jinja2.Template("""
 {% if pending_acls %}
+{% if session['nickname'] == username %}
 <a class="btn btn-success" target="_blank" href="https://admin.fedoraproject.org/pkgdb/acl/pending/">Manage requests</a>
 <hr/>
+{% endif %}
 <ul class="media-list">
 {% for acl in pending_acls %}
     <li class="media">
@@ -55,6 +57,7 @@ def data(session, widget, username):
     data = response.json()
     for acl in data['pending_acls']:
         acl['avatar'] = username2avatar(acl['user'], s=32)
+    data['username'] = username
     return data
 
 
diff --git a/hubs/widgets/workflow/updates2stable.py b/hubs/widgets/workflow/updates2stable.py
index da410db..59860a7 100644
--- a/hubs/widgets/workflow/updates2stable.py
+++ b/hubs/widgets/workflow/updates2stable.py
@@ -11,8 +11,10 @@ import hubs.validators as validators
 # TODO -- add approve/deny buttons or just link through to pkgdb
 template = jinja2.Template("""
 {% if updates %}
+{% if session['nickname'] == username %}
 <a class="btn btn-success" target="_blank" href="https://admin.fedoraproject.org/updates/mine">Manage updates</a>
 <hr/>
+{% endif %}
 <ul class="media-list">
 {% for update in updates %}
     <li class="media">

